/***************************************************************************
 *   Copyright (C) 2007 by Mateusz Dworak aka compbatant                   *
 *   compbatant@linux.pl                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "Command.hpp"


void Command::init(FileList * _filelist, string _name, CommandInfo _cmdInfo)
{
	fileList=_filelist;
	name=_name;
	exclusive=false;
	canceledExecution=false;
	param="";
	cmdInfo=_cmdInfo;
}

void Command::setParam(const string & theValue)
{

		param = theValue;
		
		typedef boost::tokenizer<boost::char_separator<char> >  tokenizer;
  		boost::char_separator<char> sep(":");
  		tokenizer tokens(param, sep);
	
		for (tokenizer::iterator tokIter = tokens.begin();tokIter != tokens.end(); ++tokIter)
		{
			string pair=*tokIter;
			int pos=pair.find("=");
			string name=pair.substr(0,pos);
			string value=pair.substr(pos+1,pair.length());
			params[name]=value;
		}
		


}

void CommandOpposite::init(FileList * _filelist, string _name, CommandInfo _cmdInfo)
{
	Command::init(_filelist,_name,_cmdInfo);
	fileListOpposite=_filelist->getOpposite();
	
	if(!fileListOpposite)
	throw exception();
	
	fileListOpposite->acquire();
}

CommandOpposite::~ CommandOpposite()
{
	if(fileListOpposite)
	fileListOpposite->release();
}


