/***************************************************************************
 *   Copyright (C) 2007 by Mateusz Dworak aka compbatant                   *
 *   compbatant@linux.pl                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "CommandInfo.hpp"


int CommandInfo::maxNr=1000;


CommandInfo::CommandInfo(string _name, string _type,string _iconName )
:name(_name),
 type(_type),
 iconName(_iconName),
 needSelectedFile(false),
 needSecondFileList(false),
 needLocalVFS(false), 
 forceReload(false),
 description(_name)
{
	nr=++maxNr;
}


CommandInfo::~CommandInfo()
{
}

map< string, string > CommandInfo::getMap( void )
{
	map<string,string>cmd;
	cmd["name"]=name;
	cmd["icon"]=iconName;
	cmd["exec"]=exec;
	cmd["type"]=type;
	cmd["key"]=key;
	cmd["key_mask"]=keyMask;
	cmd["lib"]=libName;
	cmd["param"]=param;
	cmd["alias"]=alias;
	
	if(description!=name)
	cmd["description"]=description;
	
	if(gesture!="")
	cmd["gesture"]=gesture;
	
	if(forceReload)
	cmd["force_reload"]="true";
	
	if(runAsThread)
		cmd["thread"]="yes";
	else
		cmd["thread"]="no";
	
	if(needSelectedFile)
		cmd["need_selected_file"]="true";
	
	return cmd;
}


