/***************************************************************************
 *   Copyright (C) 2007 by Mateusz Dworak aka compbatant                   *
 *   compbatant@linux.pl                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef COMMANDINFO_HPP
#define COMMANDINFO_HPP

#include <string>
#include <map>
using namespace std;

/**
	@author Mateusz Dworak aka compbatant <m@nao.linux.pl>
*/






class CommandInfo
{
public:
    CommandInfo(
    	string _name,
    	string type,
    	string _iconName=""
    	);
    	
	CommandInfo(){}
	~CommandInfo();    
	map<string,string> getMap(void);

	void setName(const string& theValue)
	{
	    name = theValue;
	}
	

	string getName() const
	{
	    return name;
	}

	void setNeedSelectedFile(bool theValue)
	{
	    needSelectedFile = theValue;
	}
	

	bool getNeedSelectedFile() const
	{
	    return needSelectedFile;
	}

	void setNeedSecondFileList(bool theValue)
	{
	    needSecondFileList = theValue;
	}
	

	bool getNeedSecondFileList() const
	{
	    return needSecondFileList;
	}

	void setNeedLocalVFS(bool theValue)
	{
	    needLocalVFS = theValue;
	}
	

	bool getNeedLocalVFS() const
	{
	    return needLocalVFS;
	}

	void setIconName(const string& theValue)
	{
	    iconName = theValue;
	}
	

	string getIconName() const
	{
	    return iconName;
	}

	void setExec(const string& theValue)
	{
	    exec = theValue;
	}
	

	string getExec() const
	{
	    return exec;
	}

	void setType(const string& theValue)
	{
	    type = theValue;
	}
	

	string getType() const
	{
	    return type;
	}

	int getNr() const
	{
	    return nr;
	}

	void setKey(const string& theValue)
	{
	    key = theValue;
	}
	

	string getKey() const
	{
	    return key;
	}

	void setKeyMask(const string& theValue)
	{
	    keyMask = theValue;
	}
	

	string getKeyMask() const
	{
	    return keyMask;
	}

	void setLibName(const string& theValue)
	{
	    libName = theValue;
	}
	

	string getLibName() const
	{
	    return libName;
	}

	void setRunAsThread ( bool theValue )
	{
		runAsThread = theValue;
	}
	

	bool getRunAsThread() const
	{
		return runAsThread;
	}

	void setParam ( const string& theValue )
	{
		param = theValue;
	}
	

	string getParam() const
	{
		return param;
	}

	void setAlias ( const string& theValue )
	{
		alias = theValue;
	}
	

	string getAlias() const
	{
		return alias;
	}

	void setDescription ( const string& theValue )
	{
		description = theValue;
	}
	

	string getDescription() const
	{
		return description;
	}

	void setForceReload ( bool theValue )
	{
		forceReload = theValue;
	}
	

	bool getForceReload() const
	{
		return forceReload;
	}

	void setGesture ( const string& theValue )
	{
		gesture = theValue;
	}
	

	string getGesture() const
	{
		return gesture;
	}
	
	
	
	
	
	
	
	

	
private:
	string name;
	string description;
	bool needSelectedFile;
	bool needSecondFileList;
	bool needLocalVFS;
	string iconName;
	string exec;
	string type;
	static int maxNr;
	string key;
	string keyMask;
	int nr;
	string libName;
	string param;
	string alias;
	bool runAsThread;
	bool forceReload;
	string gesture;
};

#endif
