/***************************************************************************
 *   Copyright (C) 2007 by Mateusz Dworak aka compbatant                   *
 *   compbatant@linux.pl                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "File.hpp"
#include "FilesEngine.hpp"

File::File()
 : type(0)
{
}


File::~File()
{
}

bool File::normal( )
{
	if(name!=".." && name!=".")
	return true;
	else
	return false;

}

bool File::hidden( )
{
	if(name.substr(0,1)==".")
	return true;
	else
	return false;
}

bool File::isUserExecutable( ) const
{

		if(mode&S_IXOTH)
		return true;
		
		if(mode&S_IXUSR)
		{
			if(user==FilesEngine::getCurrentUser())
			return true;
		}
		
		if(mode&S_IXGRP)
		{
			vector<string>groups=FilesEngine::getCurrentGroups();
			vector<string>::iterator iter;
			for(iter=groups.begin();iter!=groups.end();++iter)
			{
				if(*iter==group)
				return true;
			}
		}
		
		
		return false;
		
}




