/***************************************************************************
 *   Copyright (C) 2007 by Mateusz Dworak aka compbatant                   *
 *   compbatant@linux.pl                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef FILEICON_H
#define FILEICON_H

#include "File.hpp"

#include <string>
#include <vector>
using namespace std;

/**
	@author Mateusz Dworak aka compbatant <m@nao.linux.pl>
*/
class FileIcon
{
public:
	FileIcon(){}
	FileIcon(File file);
	~FileIcon();

	bool operator==(const FileIcon &file) const
	{
		if(getFile().getPath()==file.getFile().getPath())
			return true;
		else
			return false;
	}

	void setShowName(const string& theValue)
	{
	    showName = theValue;
	}
	

	string getShowName() const
	{
	    return showName;
	}

	void setIconName(const string& theValue)
	{
	    iconName = theValue;
	}
	

	string getIconName() const
	{
	    return iconName;
	}
	

	File getFile() const
	{
	    return file;
	}

	void setExtraIconName(const string& theValue)
	{
	    extraIconName = theValue;
	}
	

	string getExtraIconName() const
	{
	    return extraIconName;
	}

	void setPreviewIcon ( int theValue )
	{
		previewIcon = theValue;
	}
	

	int getPreviewIcon() const
	{
		return previewIcon;
	}

	void setFile ( const File& theValue )
	{
		file = theValue;
	}

	void setBackColor ( const string& theValue )
	{
		backColor = theValue;
	}
	

	string getBackColor() const
	{
		return backColor;
	}

	void setColor ( const string& theValue )
	{
		color = theValue;
	}
	

	string getColor() const
	{
		return color;
	}
	
	
	
	
	
	
	
	
	


    
private:    
    string showName;
    string iconName;
    string extraIconName;
    string backColor;
    string color;
    File file;
    int previewIcon;
    
    
    

};

#endif
