/***************************************************************************
 *   Copyright (C) 2007 by Mateusz Dworak aka compbatant                   *
 *   compbatant@linux.pl                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "MimeInfo.hpp"

MimeInfo::MimeInfo(string _name)
 : name(_name), empty(false)
{
	if(name.find ("/")!=-1)
		subMime=true;
	else
		subMime=false;	
}


MimeInfo::~MimeInfo()
{
}

map< string, vector<string> > MimeInfo::getMap(void )
{
	map<string,vector<string> >mime;
	vector<string>v1;
	v1.push_back(name);
	mime["name"]=v1;
	v1[0]=icon;
	mime["icon"]=v1;
	if(defaultCommand!="")
	{
	v1[0]=defaultCommand;
	mime["default"]=v1;
	}
	
	if(color!="")
	{
	v1[0]=color;
	mime["color"]=v1;
	}
	
	if(backColor!="")
	{
	v1[0]=backColor;
	mime["backcolor"]=v1;
	}
	
	if(commands.size()>0)
	{
	mime["command"]=commands;
	}
	
	return mime;
}

MimeInfo MimeInfo::CreateEmpty(string name)
{
	MimeInfo mimeInfo(name);
	mimeInfo.setEmpty(true);
	return mimeInfo;
}





