/***************************************************************************
 *   Copyright (C) 2007 by Mateusz Dworak aka compbatant                   *
 *   compbatant@linux.pl                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef QUESTION_HPP
#define QUESTION_HPP

#include "QuestionManager.hpp"
#include "WindowContent.hpp"
#include "File.hpp"
#include "Exceptions.hpp"

#include <string>
#include <map>
using namespace std;




/**
	@author Mateusz Dworak aka compbatant <m@nao.linux.pl>
*/
class Question
{
public:
	Question(){}
	Question(QuestionManager *questionManager);
	static string askString(QuestionManager *questionManager,string question,string text="");
	string askStringQ(string question,string text="");
	static void displayError(QuestionManager *questionManager,string message);
	void displayErrorQ(string message);
	static map<string,string> askCustom(QuestionManager *questionManager,WindowContent &windowContent);
	map<string,string> askCustomQ(WindowContent &windowContent);
	static string askOverwrite(QuestionManager *questionManager,File file, string question);
	static string askYesNo(QuestionManager *questionManager,string question);
	string askYesNoQ(string question);
	static void displayException(QuestionManager *questionManager,ExceptionFileSystem &excep);
private:
	QuestionManager *questionManager;	
};

#endif
