/***************************************************************************
 *   Copyright (C) 2007 by Mateusz Dworak aka compbatant                   *
 *   compbatant@linux.pl                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "ThreadCommand.hpp"
#include "Exceptions.hpp"

ThreadCommand::ThreadCommand(Command *_cmd)
 : cmd(_cmd)
{

}


ThreadCommand::~ThreadCommand()
{
delete cmd;
}

void ThreadCommand::execute( )
{
	start();
}

int ThreadCommand::run( )
{	
	
		
	if(cmd->getExclusive())	
	{
	cmd->getFileList()->waitForThreads();
	}	
		
	cmd->getFileList()->startThreadProcessing(this);	
		
		
	try
	{	
	cmd->execute();	
	}
	catch(ExceptionNoDescription &e)
	{
		Question::displayError(cmd->getFileList()->getFileListIcons(),"Support for this feature not compiled");
	}
	catch(ExceptionSupportNotCompiled &e)
	{
	}
	catch(ExceptionFileSystem &e)
	{
		Question::displayException(cmd->getFileList()->getFileListIcons(),e);
	}
	catch(...)
	{
		Question::displayError(cmd->getFileList()->getFileListIcons(),"command failed");
	}
	
	cmd->getFileList()->stopThreadProcessing(this);
	
}

void ThreadCommand::setCanceledExecution()
{
	cmd->setCanceledExecution();
}



