/***************************************************************************
 *   Copyright (C) 2007 by Mateusz Dworak aka compbatant                   *
 *   compbatant@linux.pl                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "WindowContent.hpp"

WindowContent::WindowContent():count(0),width(340),height(100),title("nao")
{

}


WindowContent::~WindowContent()
{
	vector<Widget*>::iterator iter; 
	for(iter=widgets.begin();iter!=widgets.end();++iter)
	{
		delete *iter;
	}
	
}


Widget* WindowContent::getNext()
{
	if(count<widgets.size())
	{		
	++count;
	return widgets[count-1];
	}
	else
	throw exception();
	
}


void WindowContent::addWidgetVerticalFrame(string parentName, string name)
{
	WidgetVerticalFrame *widget=new WidgetVerticalFrame(parentName,name);
	widgets.push_back(widget);
}

void WindowContent::addWidgetHorizontalFrame(string parentName, string name)
{
	WidgetHorizontalFrame *widget=new WidgetHorizontalFrame(parentName,name);
	widgets.push_back(widget);
}



void WindowContent::addWidgetButton(string parentName, string name, string value, string iconName)
{
	WidgetButton *widget=new WidgetButton(parentName,name,value,iconName);
	widgets.push_back(widget);
}

void WindowContent::addWidgetTextField(string parentName, string name, string value, int fieldsNum,string style)
{
	WidgetTextField *widget=new WidgetTextField(parentName,name,value,fieldsNum,style);
	widgets.push_back(widget);
}

void WindowContent::addWidgetLabel(string parentName, string name, string value, string iconName)
{
	WidgetLabel*widget=new WidgetLabel(parentName,name,value,iconName);
	widgets.push_back(widget);
}

void WindowContent::setSize(int _width, int _height)
{
	width=_width;
	height=_height;
}

void WindowContent::addWidgetCheckButton(string parentName, string name, string label, bool value)
{
	WidgetCheckButton *widget=new WidgetCheckButton(parentName,name,label,value);
	widgets.push_back(widget);
}

void WindowContent::addWidgetGroupBox(string parentName, string name, string value)
{
	WidgetGroupBox *widget=new WidgetGroupBox(parentName,name,value);
	widgets.push_back(widget);
}

void WindowContent::addWidgetComboBox(string parentName, string name, vector< string > values,int fieldsNum)
{
	WidgetComboBox *widget=new WidgetComboBox(parentName,name,values,fieldsNum);
	widgets.push_back(widget);
}


