/***************************************************************************
 *   Copyright (C) 2007 by Mateusz Dworak aka compbatant                   *
 *   compbatant@linux.pl                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#ifndef CMDCOPY_HPP
#define CMDCOPY_HPP

#include "../Command.hpp"
#include "../libfactory/ClassFactory.hpp"
#include "../libfactory/Factorable.hpp"

/**
	@author Mateusz Dworak aka compbatant <m@nao.linux.pl>
*/
class CmdCopy : public CommandOpposite, public Factorable
{
public:
    virtual void execute();
    virtual void init(FileList *_filelist,string _name,CommandInfo _cmdInfo);
    
private:

	void setTotalSize(Vfs *vfs,vector< path >& files,Status * status);
	void copy(FileList *fileList1, FileList *fileList2,vector< path > files, path destination,bool move=false);

	Status *status;

};

#endif
