/***************************************************************************
 *   Copyright (C) 2007 by Mateusz Dworak aka compbatant                   *
 *   compbatant@linux.pl                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "CmdCreateDir.hpp"
#include "Exceptions.hpp"

REGISTER_FACTORABLE(CmdCreateDir);



void CmdCreateDir::execute( )
{
	path directory=fileList->getCurrentDirectory();
	try
	{
	string newDirName=Question::askString(fileList->getFileListIcons(),"directory name:");
		if(newDirName!="")
		{
			path newPath=directory/path(newDirName);
			fileList->getVfs()->createDir(newPath);
			/*TODO*/
			fileList->addFile(newPath.string());
			fileList->sort();
		}
	}
	catch(ExceptionCancel &e)
	{
	}
	catch(ExceptionAccess &e)
	{
		Question::displayError(getFileList()->getFileListIcons(),"You don't have privileges to create directory: "+e.getFileName());	
	}
	catch(ExceptionAlreadyExist &e)
	{
		Question::displayError(getFileList()->getFileListIcons(),"Directory already exists: "+e.getFileName());	
	}
	catch(ExceptionNoEnoughSpace &e)
	{
		Question::displayError(getFileList()->getFileListIcons(),"Not enough free space for: "+e.getFileName());	
	}		
	catch(...)
	{
		Question::displayError(getFileList()->getFileListIcons(),"error creating directory");	

	}	

}




