/***************************************************************************
 *   Copyright (C) 2007 by Mateusz Dworak aka compbatant                   *
 *   compbatant@linux.pl                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#include "CmdPythonPlugin.hpp"

#include "Exceptions.hpp"
#include "Settings.hpp"
#include "FilesEngine.hpp"
#include "binreloc.h"

/*IMPORTANT config.h first*/
#include "config.h"
#include "../PluginsEngine.hpp"

REGISTER_FACTORABLE(CmdPythonPlugin);


CmdPythonPlugin::~CmdPythonPlugin()
{
}

void CmdPythonPlugin::execute()
{

	
	
	#ifdef HAVE_BOOST_PYTHON
	
	Settings &settings=singleton<Settings>::instance();
	CommandInfo cmdInfo=settings.getCommand(name);
	string pluginPath;
	
	pluginPath=FilesEngine::getHomeDir().string()+"/.nao/python_plugins/"+cmdInfo.getExec()+".py";
	path p=pluginPath;
	if(!FilesEngine::exists(p))
	{
		pluginPath=string(br_find_lib_dir(PATH_LIBDIR))+"/nao/python_plugins/"+cmdInfo.getExec()+".py";

	}
	p=pluginPath;
	if(FilesEngine::exists(p))
	{	
		PluginsEngine& pluginsEngine=singleton<PluginsEngine>::instance();
		pluginsEngine.runPythonPlugin(pluginPath,fileList);
	}
	#else
	throw ExceptionSupportNotCompiled();	
	#endif
}


