/***************************************************************************
 *   Copyright (C) 2007 by Mateusz Dworak aka compbatant                   *
 *   compbatant@linux.pl                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#ifndef STANDARDCOMMANDS_HPP
#define STANDARDCOMMANDS_HPP

#include "../Command.hpp"
#include "../libfactory/ClassFactory.hpp"
#include "../libfactory/Factorable.hpp"


/**
	@author Mateusz Dworak aka compbatant <m@nao.linux.pl>
*/
class CmdSmallIconsView : public Command, public Factorable
{
public:
	virtual void execute();
};

class CmdBigIconsView : public Command, public Factorable
{
public:
	virtual void execute();
};

class CmdDetailsIconsView : public Command, public Factorable
{
public:
	virtual void execute();
};

class CmdSwitchPanelsView : public Command, public Factorable
{
public:
	virtual void execute();
};

class CmdGotoOppositePanel: public CommandOpposite, public Factorable
{
public:
	virtual void execute();
};

class CmdOpenOpposite: public CommandOpposite, public Factorable
{
public:
	virtual void execute();
};

class CmdSelectAll: public Command, public Factorable
{
public:
	virtual void execute();
};


class CmdTotalSize: public Command, public Factorable
{
public:
	virtual void execute();
};

class CmdShowPreview: public Command, public Factorable
{
public:
	virtual void execute();
};

class CmdOpenDirectory: public Command, public Factorable
{
public:
	virtual void execute();
};

class CmdOpenPreviousInHistory: public Command, public Factorable
{
public:
	virtual void execute();
};

class CmdEnlargePreview: public Command, public Factorable
{
public:
	virtual void execute();
};
class CmdReducePreview: public Command, public Factorable
{
public:
	virtual void execute();
};

class CmdStopThreads: public Command, public Factorable
{
public:
	virtual void execute();
};

class CmdOpenLocalVfs: public Command, public Factorable
{
public:
	virtual void execute();

};

class CmdOpenRemoteVfs: public Command, public Factorable
{
public:
	virtual void execute();
};

class CmdChmod: public Command, public Factorable
{
public:
	virtual void execute();
};

class CmdRemove: public Command, public Factorable
{
public:
	virtual void execute();
};

class CmdRename: public Command, public Factorable
{
public:
	virtual void execute();
};

class CmdOpenParentDirectory: public Command, public Factorable
{
public:
	virtual void execute();
};

class CmdOpenHomeDirectory: public Command, public Factorable
{
public:
	virtual void execute();
};

class CmdRefresh: public Command, public Factorable
{
public:
	virtual void execute();
};

class CmdShowHideHiddenFiles: public Command, public Factorable
{
public:
	virtual void execute();
};

class CmdChangeOwner: public Command, public Factorable
{
public:
	virtual void execute();
};

class CmdChangeGroup: public Command, public Factorable
{
public:
	virtual void execute();
};

class CmdCreateSymlink: public CommandOpposite, public Factorable
{
public:
	virtual void execute();
};

class CmdClone: public Command, public Factorable
{
public:
	virtual void execute();
};

class CmdGetFileInformation: public Command, public Factorable
{
public:
	virtual void execute();
};

class CmdClipboardCopy: public Command, public Factorable
{
public:
	virtual void execute();
};

class CmdClipboardCut: public Command, public Factorable
{
public:
	virtual void execute();
};

class CmdClipboardPaste: public Command, public Factorable
{
public:
	virtual void execute();
};

class CmdOpenPath: public Command, public Factorable
{
public:
	virtual void execute();
};

class CmdRunCommand: public Command, public Factorable
{
public:
	virtual void execute();
};

class CmdOpenFlatDirectory: public Command, public Factorable
{
public:
	virtual void execute();
};

class CmdOpenHistoryVfs: public Command, public Factorable
{
public:
	virtual void execute();
};

class CmdOpenSearchVfs: public Command, public Factorable
{
public:
	virtual void execute();
};

class CmdOpenArchiveVfs: public Command, public Factorable
{
public:
	virtual void execute();
};

class CmdRegexSelection : public Command, public Factorable
{
public:
    virtual void execute();
private:
	static vector<string>last;    

};

class CmdRegexFilter : public Command, public Factorable
{
public:
    virtual void execute();
private:
	static vector<string>last;    

};

class CmdAddDirToShortcuts: public Command, public Factorable
{
public:
	virtual void execute();
};


#endif
