/***************************************************************************
 *   Copyright (C) 2006 by Mateusz Dworak aka compbatant                   *
/***************************************************************************
 *   Copyright (C) 2007 by Mateusz Dworak aka compbatant                   *
 *   compbatant@linux.pl                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#ifndef FOXFILELISTPANEL_HPP
#define FOXFILELISTPANEL_HPP

#include "config.h"

#include <fx.h>

#ifdef  HAVE_LIBFOX_1_4
#include <FXGUISignal.h>
#endif


#include "FoxPanel.hpp"
#include "FoxFileList.hpp"
#include "FoxGuiThreadSynchronization.hpp"

#include <vector>

class FoxFileListPanelMessagesHandler;

/**
	@author Mateusz Dworak aka compbatant <m@nao.linux.pl>
*/
class FoxFileListPanel : public FoxPanel, public FXObject
{
FXDECLARE(FoxFileListPanel);

public:
    FoxFileListPanel(FoxPanelManager *foxPanelManager,string param="");
    virtual ~FoxFileListPanel();
    void setPath( string );   
    void openPath(string);
    void listPath(string path);
    
    long onPathButtonOpen (FXObject * sender, FXSelector, void *);
    long onOpenDir (FXObject * sender, FXSelector, void *);
    
    virtual void moveToRight(void);
    virtual void moveToLeft(void);
    virtual void moveToTop(void);
    virtual void setOpposite(FoxPanel* theValue);
    virtual void directoryLoaded();
    
    virtual void enable();
    virtual void disable();
    virtual bool canClose();
    virtual void setLabel(string text, string iconName="");
    virtual void setFocus(void);
    virtual void createPanel(string name, string param );
    
	
	enum
	{
	ID_PATHBUTTON,
	ID_PATHROOTBUTTON,
	ID_OPENDIR,
		
	};
	
	FoxFileList* getFoxFileList() const
	{
	    return foxFileList;
	}
    
private:

	void setPathSync( string );
	void createPanelSync(string name, string param );

	vector<FXButton*>buttons; 
	vector<FXButton*>::iterator buttonsIterator; 
	bool constructor;
	FoxFileList *foxFileList;
	FXMenuPane *directoriesMenu;
	string currentDirectory;
	FoxFileListPanel(){}	
	int x,y;
	FoxPanel *opposite;
	
	pthread_t p_id;
	FXGUISignal *guiSignal;
	boost::mutex mutexS;
	FoxSingalReceiver foxSingalReceiver;
	bool list;
	bool enabled;

};

#endif
