/***************************************************************************
 *   Copyright (C) 2007 by Mateusz Dworak aka compbatant                   *
 *   compbatant@linux.pl                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "FoxIconManager.hpp"
#include "../vfs/VfsLocal.hpp"
#include "Settings.hpp"
#include "config.h"



FXIcon* FoxIconManager::get( string name )
{
	return icons[name];
}



FoxIconManager::FoxIconManager( FXApp * app )
{

source = new FXIconSource ( app );

path dir=singleton<Settings>::instance().getIconsDir();

	try
	{
		VfsLocal vfs;
		Directory directory=vfs.openDir( dir );		
			
		while(1)
		{			

			File file=directory.getNextFile();
			if(!file.normal())
			continue;

			FXString name=path(dir/path(file.getName())).string().c_str();
			string shortName=file.getName().substr ( 0, file.getName().length () - 4 );
			
			FXIcon *icon=NULL;			
			#ifdef  HAVE_LIBFOX_1_6
			icon = source->loadIconFile ( name );
			#else
			icon = source->loadIcon ( name );	
			#endif		
	
			if ( icon )
			{
				icons[shortName]=icon;
				//icon->blend(icon->getTransparentColor());
				icon->blend(app->getBaseColor());
				icon->create();
				allIconsName.push_back(shortName);
			}
		}		
	}
	catch(exception e)
	{
				
	}

}

vector< string > FoxIconManager::getAllIconsName( void )
{
	return allIconsName;
}

FoxIconManager::~FoxIconManager()
{
	/*DANGEROUS*/
	//delete source;
}




