/***************************************************************************
 *   Copyright (C) 2007 by Mateusz Dworak aka compbatant                   *
 *   compbatant@linux.pl                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "FoxPanel.hpp"
#include "FoxFileList.hpp"

FoxPanel::FoxPanel(FoxPanelManager *_foxPanelManager,string _param)
: foxPanelManager(_foxPanelManager), opposite(NULL),type("FoxPanel"),param(_param)
{
FXComposite *control,*content;
control=foxPanelManager->getControlframe();
content=foxPanelManager->getLeftframe();

FoxIconManager &foxIconManager=FoxSingleton<FoxIconManager>::instance( content->getApp());
	guiSignal= new FXGUISignal (foxPanelManager->getLeftcontrolframe()->getApp(), foxPanelManager->getTarget(),ID_QUIT);
	
	
    hf = new FXHorizontalFrame ( control, LAYOUT_FILL_X | FRAME_THICK, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 );
    toleft = new FXButton ( hf, "", foxIconManager.get("left"),foxPanelManager->getTarget(), ID_LEFT , FRAME_THICK, 0, 0, 0, 0, 0, 0, 0, 0 );
    toleft->setUserData(this);
    toclose = new FXButton ( hf, "", foxIconManager.get("close"), foxPanelManager->getTarget(), ID_QUIT, FRAME_THICK, 0, 0, 0, 0, 0, 0, 0, 0 );
    toclose->setUserData(this);
    toright = new FXButton ( hf, "", foxIconManager.get("right"), foxPanelManager->getTarget(), ID_RIGHT, FRAME_THICK, 0, 0, 0, 0, 0, 0, 0, 0 );
    toright->setUserData(this);
    
    label = new FXButton ( hf, "", NULL, NULL, 0, FRAME_THICK | ICON_BEFORE_TEXT, 0, 0, 0, 0, 0, 0, 0, 0 );
   
    frame = new FXVerticalFrame ( content, LAYOUT_FILL_X | LAYOUT_FILL_Y | FRAME_SUNKEN, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 );
    frame->hide();

}


FoxPanel::~FoxPanel()
{
delete hf;
delete frame;
}

void FoxPanel::moveToRight( void )
{
	setOpposite(NULL);
   	controlHide();
	hf->reparent ( foxPanelManager->getRightcontrolframe() );	
	frame->reparent ( foxPanelManager->getRightframe() );
	frame->show();
	 
		
}

void FoxPanel::moveToLeft( void )
{
	setOpposite(NULL);
	controlHide();
	hf->reparent ( foxPanelManager->getLeftcontrolframe() );
	frame->reparent ( foxPanelManager->getLeftframe() );
	frame->show();
	
}

void FoxPanel::moveToTop( void )
{
	setOpposite(NULL);
	hf->reparent ( foxPanelManager->getControlframe() );
	controlShow();
	frame->hide();
	
}

void FoxPanel::controlHide( void )
{
    toleft->hide();
    toclose->hide();
    toright->hide();
}

void FoxPanel::controlShow( void )
{
    toleft->show();
    toclose->show();
    toright->show();
}

void FoxPanel::recalc( void )
{

	frame->recalc();
	hf->recalc();
	foxPanelManager->getControlframe()->recalc();
	foxPanelManager->getLeftframe()->recalc();
	foxPanelManager->getLeftcontrolframe()->recalc();
	foxPanelManager->getRightframe()->recalc();
	foxPanelManager->getRightcontrolframe()->recalc();
}

void FoxPanel::setPath( string )
{

}


void FoxPanel::setOpposite(FoxPanel* theValue)
{
    opposite = theValue;
}



void FoxPanel::setPanelWidth( int width )
{
	foxPanelManager->setPanelWidth(this,width);
}


void FoxPanel::directoryLoaded()
{

}

void FoxPanel::enable()
{
}

void FoxPanel::disable()
{
}


bool FoxPanel::canClose()
{
	return true;
}	


void FoxPanel::createPanel(string name, string param)
{
	
}

void FoxPanel::create()
{
	hf->create();
	frame->create();
}

string FoxPanel::getParam()
{
	return param;

}

void FoxPanel::setLabel(string text, string iconName)
{
	label->setText(text.c_str());
	if(iconName!="")
	{
		FoxIconManager &foxIconManager=FoxSingleton<FoxIconManager>::instance( foxPanelManager->getLeftframe()->getApp());
		label->setIcon(foxIconManager.get(iconName));
	}
}

void FoxPanel::close()
{
	guiSignal->signal();
}


void FoxPanel::setFocus(void )
{
}


