/***************************************************************************
 *   Copyright (C) 2007 by Mateusz Dworak aka compbatant                   *
 *   compbatant@linux.pl                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "FoxShutter.hpp"
#include <iostream>
using namespace std;



FXDEFMAP ( FoxShutter ) FoxShutterMap[] =
{
    FXMAPFUNC( SEL_MOUSEWHEEL, 0, FoxShutter::onMouseWheel ),
    FXMAPFUNC( SEL_COMMAND, FoxShutter::ID_OPEN_SHUTTERITEM, FoxShutter::onOpenItem )
};

FXIMPLEMENT( FoxShutter, FXShutter, FoxShutterMap, ARRAYNUMBER ( FoxShutterMap ) )


FoxShutter::~FoxShutter()
{

}


FoxShutter::FoxShutter( FXComposite * p, FXWindow * x ) : FXShutter( p, x, 6667, FRAME_NONE | LAYOUT_FILL_Y | LAYOUT_FILL_X | LAYOUT_TOP | LAYOUT_LEFT | LAYOUT_FIX_WIDTH, 0, 0, 90, 0, 0, 0, 0, 0, 0, 0 )
{
    setLayoutHints( FRAME_NONE | LAYOUT_FILL_Y | LAYOUT_FILL_X | LAYOUT_TOP | LAYOUT_LEFT );
}


long FoxShutter::onMouseWheel( FXObject *, FXSelector , void * ptr )
{
	FXEvent * event = ( FXEvent * ) ptr;
	
	int x;
	if ( event->code < 0 )
	{
		x = getCurrent () + 1;
		if ( x > numChildren () - 1 )
		x = 0;
		setCurrent ( x );
	}
	
	if ( event->code > 0 )
	{
		x = getCurrent () - 1;
		if ( x == -1 )
		x = numChildren () - 1;
		setCurrent ( x );
	}
	
	FXMenuPane *menu = ( FXMenuPane * ) this->getParent ();
	menu->resize ( menu->getWidth(), getHeight() );
	
	return 1;
}

long FoxShutter::onOpenItem( FXObject *sender, FXSelector sel , void * ptr )
{
	FXShutter::onOpenItem ( sender, sel, ptr );
	
	FXMenuPane *menu = ( FXMenuPane * ) ( ( FXWindow * ) sender ) ->getParent () ->getParent ();
	menu->resize ( menu->getWidth(), getHeight () );

	return 1;
}

int FoxShutter::getHeight( void )
{
	int height_size = 0;
	FXShutterItem *test = ( FXShutterItem * ) this->getFirst ();
	int x = getCurrent ();
	int zz = 0;
	int vspace=0;
	
	while ( test )
	{
		if ( zz == x )
		{
		FXButton * wind =(FXButton*) test->getContent () ->getFirst ();
	
		while ( wind )
		{
		
		
			int height=wind->getFont()->getTextHeight("I")+2*wind->getBorderWidth ();
			FXIcon*icon=wind->getIcon();
			if(icon)
			{
				if(icon->getHeight() > wind->getFont()->getTextHeight("I"))
				{
					height=icon->getHeight()+2*wind->getBorderWidth ();
					
				}			
			}

			height_size += height;
			wind =(FXButton*) wind->getNext ();
		}
	
		}
		test = ( FXShutterItem * ) test->getNext ();
		zz++;
	}
	if ( this->getFirst () != NULL )
	{
	FXShutterItem *test = ( FXShutterItem * ) this->getFirst ();
	FXIcon*icon=test->getButton()->getIcon();
	
	int height=icon->getHeight()+2*test->getButton()->getBorderWidth ();
	
	/*
	int height=test->getButton()->getFont()->getTextHeight("I")+2*test->getButton()->getBorderWidth ()+test->getContent()->getPadTop()+test->getContent()->getPadBottom();
	*/		
	height_size +=(height*zz)+4;
	
		/*height_size += ( ( ( FXShutterItem * ) this->getFirst () ) ->getButton () ->getFont()->getTextHeight("I") + \
			         ( ( FXShutterItem * ) this->getFirst () )->getButton () ->getBorderWidth ()*2 ) * zz+6;*/
	}
	
	return height_size;
}

void FoxShutter::setWidth(int _width)
{
	width=_width;
}


