/***************************************************************************
 *   Copyright (C) 2007 by Mateusz Dworak aka compbatant                   *
 *   compbatant@linux.pl                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef FOXSINGLETON_HPP
#define FOXSINGLETON_HPP

#include <fx.h>
#include<iostream>
using namespace std;

/**
	@author Mateusz Dworak aka compbatant <m@nao.linux.pl>
*/

template <class T>
class FoxSingleton : private T
{
private:
    FoxSingleton(FXApp* app);
    ~FoxSingleton();

public:
    static T &instance(FXApp* app);
};


template <class T>
inline FoxSingleton<T>::FoxSingleton(FXApp* app)
	:T(app)
{
    /* no-op */
}

template <class T>
inline FoxSingleton<T>::~FoxSingleton()
{
    /* no-op */
}

template <class T>
/*static*/ T &FoxSingleton<T>::instance(FXApp* app)
{
    // function-local static to force this to work correctly at static
    // initialization time.
    static FoxSingleton<T> s_oT(app);
    return(s_oT);
}





#endif
