/***************************************************************************
 *   Copyright (C) 2007 by Mateusz Dworak aka compbatant                   *
 *   compbatant@linux.pl                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include "config.h"

#include <boost/filesystem/path.hpp>
#include <boost/program_options.hpp>
#include <iostream>

#include <locale.h> 
#include <libintl.h>
#define _(STRING)    gettext(STRING)

#ifdef HAVE_LIBFOX_1_6 
	#define FOX_GUI
#endif	

#ifdef HAVE_LIBFOX_1_4 
	#define FOX_GUI
#endif


#ifdef FOX_GUI
	#include "FoxStartup.hpp"
#endif

#include "AutoConfigurator.hpp"

#include "binreloc.h"

using namespace boost::filesystem;
using namespace std;
namespace po = boost::program_options;

static void __attribute__((constructor))
init_binreloc () 
{
	br_init(NULL);
}

int main(int argc, char *argv[])
{

	char *program_domain;
	setlocale(LC_ALL, "");
	program_domain = textdomain ("nao"); 

	path::default_name_check(no_check);
	
	po::options_description desc(_("Allowed options"));
	desc.add_options()
    	("help", _("produce help message"))
	;

	po::variables_map vm;
		try
		{
		po::store(po::parse_command_line(argc, argv, desc), vm);
		}
		catch(po::unknown_option& ex)
		{
			cout << _("unknown option") << endl;
			return -1;
		}
	po::notify(vm); 
	
	if (vm.count("help"))
	{
		cout << desc << endl;
		return 0;
	}
	

	
	
	#ifdef FOX_GUI
		
	FoxStartup startup;
	startup.start(argc,argv);
	
	#else
	
	cout<<_("only FOX gui is current availible, compile nao with fox")<<endl;
	
	#endif
	

return 0;
}
